''' (c) 2008 by the GunGame Coding Team

    Title: gg_cheap_equip
    Version: 1.0.1
    Description: Custom addon.
    '''

# ==============================================================================
#   IMPORTS
# ==============================================================================
# EventScripts imports
import es
import gamethread

# GunGame imports
import gungamelib

# ==============================================================================
#   ADDON REGISTRATION
# ==============================================================================
# Register this addon with EventScripts
info = es.AddonInfo()
info.name     = '!equip command to re-equip you at any time for GunGame 5'
info.version  = '1.0.1'
info.url      = 'http://forums.gungame5.com/viewtopic.php?f=17&t=238'
info.basename = 'gungame/custom_addons/gg_cheap_equip'
info.author   = 'Sc0pE'

es.ServerVar('gg_cheap_equip_ver', info.version).makepublic()

# ==============================================================================
#   GLOBALS
# ==============================================================================
gg_cheap_equip_command = gungamelib.getVariableValue('gg_cheap_equip_command')
gg_cheap_equip_uses = gungamelib.getVariableValue('gg_cheap_equip_uses')
dict_players = {}

# ==============================================================================
#   GAME EVENTS
# ==============================================================================
def load():
    # Register this addon with GunGame
    gg_cheap_equip = gungamelib.registerAddon('gg_cheap_equip')
    gg_cheap_equip.setDisplayName('GG Cheap Equip')
    gg_cheap_equip.loadTranslationFile()
    
    gg_cheap_equip.registerPublicCommand(gg_cheap_equip_command, giveNewWeapon)

def unload():
    # Unregister this addon with GunGame
    gungamelib.unregisterAddon('gg_cheap_equip')

def round_start(event_var):
    dict_players.clear()

# ==============================================================================
#   HELPER FUNCTIONS
# ==============================================================================
def giveNewWeapon(userid):
    userid = int(userid)
    
    if not useCommand(userid):
        gungamelib.msg('gg_cheap_equip', userid, 'Already_Used', {'command':gg_cheap_equip_command, 'max_uses':gg_cheap_equip_uses})
        return
    
    gungamePlayer = gungamelib.getPlayer(userid)
    
    if gungamelib.isDead(userid):
        return
        
    if gungamelib.isSpectator(userid):
        return
    
    gungamePlayer.stripPlayer()
    
    # Only delay if we are on linux
    if gungamelib.getOS() == 'posix':
        gamethread.delayed(0, delayedGiveNewWeapon, (userid))
    else:
        gungamePlayer.giveWeapon()

def delayedGiveNewWeapon(userid):
    if gungamelib.isDead(userid):
        return
    
    if gungamelib.isSpectator(userid):
        return
    
    gungamePlayer = gungamelib.getPlayer(userid)
    gungamePlayer.giveWeapon()

def useCommand(userid):
    if not gg_cheap_equip_uses:
        return 1
    if not userid in dict_players:
        dict_players[userid] = 1
    if dict_players[userid] > gg_cheap_equip_uses:
        return 0
    dict_players[userid] += 1
    return 1